#include "Visitor.h"
#include "UniRndGen.h"
#include "Sched.h"

#include "Posetilac.h"

// Za resavanje zadatka pod c) potrebno je:
// prepraviti metodu acceptFlow
// i dodati u scheduler metodu (ili napraviti novu klasu 
// koja nasledjuje scheduler i ima metodu za) 
// otklanjanje svih objekata tipa event za datog posetioca 
// (koji premasi broj od M piva i izbaci ih sve odjednom)

void Posetilac::accept (Visitor* vis)
{
	if (vis) vis->visitPosetilac (this);
}

void Posetilac::acceptFlow()
{
	// Kada dobije pivo, broj piva se uvecava za 1;
	// prijavljuje se dogadjaj za Scheduler u normalnom slucaju;
	// ako je broj piva premasio M, sva piva se odmah izbacuju
	
	brojPiva++;
	if (brojPiva <= M )
		raiseEvent ();
	else
	{
		int i;
		for (i=0;i<brojPiva; i++)
			notify(0);
		Scheduler::Instance()->removeEvents(this);
	}
}

void Posetilac::notify (int ID)
{
	// Kada Scheduler obavesti Posetioca
	// on odlazi do Sanitarnog cvora
	// gde se izvrsava izbacivanje
	// jednog piva
	if (target)
	{
		send();
		brojPiva--;
	}
}
