#ifndef Posetilac_h
#define Posetilac_h 1

#include "AbstractConcepts.h"
class Visitor;

// Klasa Posetilac nasledjuje RandomTimedFlowElement 
// jer zadrzavanje piva u njemu treba da kontrolise Scheduler
class Posetilac : public RandomTimedFlowElement
{
public:
	// Inicijalizacija promenljivih kao i inicijalizacija
	// generatora slucajnih brojeva (po tekstu zadatka, Uniformni)
	Posetilac (double ZZ, int MM)
	: Z(ZZ), M(MM), RandomTimedFlowElement(new UniformGenerator (0.9*Z*60, 1.1*Z*60))
	{
		brojPiva = 0;  // posetilac u pocetku ima 0 piva u sebi
	}

	// Povezivanje sa Visitor klasama
	virtual void accept (Visitor* vis);
	
	virtual void acceptFlow();
	
	// Scheduler preko ove f-je obavestava posetioca
	virtual void notify (int ID);             

protected:
	int brojPiva;      // trenutni broj piva
	int M;             // maksimalan broj dozvoljenih piva
	double Z;          // prosecno vreme zadrzavanja jednog piva
};

#endif
