//## begin module%1.2%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.2%.codegen_version

//## begin module%3EEB40C3000A.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3EEB40C3000A.cm

//## begin module%3EEB40C3000A.cp preserve=no
//	* Copyright (C) 2003 by Dragan Milicev *
//	* All rights reserved *
//## end module%3EEB40C3000A.cp

//## Module: Sched%3EEB40C3000A; Package specification
//## Subsystem: Simulation Engine%3EEB3A44005A
//## Source file: C:\Users\DMilicev\Kursevi\Object-Oriented Technology - Tutorial\Examples\Traffic Simulation\Final Release\Code\Simulation Engine\Sched.h

#ifndef Sched_h
#define Sched_h 1

//## begin module%3EEB40C3000A.additionalIncludes preserve=no
//## end module%3EEB40C3000A.additionalIncludes

//## begin module%3EEB40C3000A.includes preserve=yes
#include "Types.h"
#include "Event.h"
//## end module%3EEB40C3000A.includes

//## begin module%3EEB40C3000A.declarations preserve=no
//## end module%3EEB40C3000A.declarations

//## begin module%3EEB40C3000A.additionalDeclarations preserve=yes
//## end module%3EEB40C3000A.additionalDeclarations


//## begin Scheduler%3EE0D27C0000.preface preserve=yes
//## end Scheduler%3EE0D27C0000.preface

//## Class: Scheduler%3EE0D27C0000
//	The scheduler of the Events sorted in chronological
//	order. Singleton.
//## Category: Traffic Modeling and Simulation::Simulation Engine%3EE07FDE00E6
//## Subsystem: Simulation Engine%3EEB3A44005A
//## Persistence: Transient
//## Cardinality/Multiplicity: 1..1

class Scheduler 
{
  //## begin Scheduler%3EE0D27C0000.initialDeclarations preserve=yes
  //## end Scheduler%3EE0D27C0000.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: Instance%3EE0D2D00064
      //	Returns the singleton instance of this class. Static.
      //	Singleton DP.
      static Scheduler* Instance ();

      //## Operation: put%3EE0D4350226
      //	Accepts a new Event to be scheduled. Puts it into the
      //	chronological list of Events.
      virtual void put (Event* ev);

      //## Operation: getCurTime%3EE0D4BE0280
      //	Returns the current simulation time (simulation clock).
      virtual Time getCurTime ();

      //## Operation: processNow%3EE0D4E6008C
      //	Processes one step of simulation, by handling the Events
      //	that are scheduled first and at the same moment. Returns
      //	true if there is more Events left after the processing.
      virtual bool processNow ();

	  ///////////////// DODATA FUNKCIJA //////////////////
	  void removeEvents(ITimedElement *target);
      /////////////////////////////////////////////////////

    // Additional Public Declarations
      //## begin Scheduler%3EE0D27C0000.public preserve=yes
      //## end Scheduler%3EE0D27C0000.public

  protected:
    //## Constructors (specified)
      //## Operation: Scheduler%3EE0D2BC03A2
      //	Constructor. Singleton DP.
      Scheduler ();


    //## Other Operations (specified)
      //## Operation: processOneEvent%3EE0D53F0118
      //	Processes the first scheduled Event (if any) by handling
      //	it. Returns true if there is more Events scheduled at
      //	the same moment left after the processing.
      virtual bool processOneEvent ();

    // Additional Protected Declarations
      //## begin Scheduler%3EE0D27C0000.protected preserve=yes
      //## end Scheduler%3EE0D27C0000.protected

  private:
    // Data Members for Class Attributes

      //## Attribute: curTime%3EE0D4A80082
      //	Current time (internal simulation clock).
      //## begin Scheduler::curTime%3EE0D4A80082.attr preserve=no  private: Time {UA} 0
      Time curTime;
      //## end Scheduler::curTime%3EE0D4A80082.attr

    // Data Members for Associations

      //## Association: Traffic Modeling and Simulation::Simulation Engine::<unnamed>%3EE0D33903AC
      //## Role: Scheduler::first%3EE0D33A021C
      //## begin Scheduler::first%3EE0D33A021C.role preserve=no  private: Event {0..1 -> 0..1RFHAN}
      Event *first;
      //## end Scheduler::first%3EE0D33A021C.role

    // Additional Private Declarations
      //## begin Scheduler%3EE0D27C0000.private preserve=yes
      //## end Scheduler%3EE0D27C0000.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Scheduler%3EE0D27C0000.implementation preserve=yes
      //## end Scheduler%3EE0D27C0000.implementation

};

//## begin Scheduler%3EE0D27C0000.postscript preserve=yes
//## end Scheduler%3EE0D27C0000.postscript

// Class Scheduler 

inline Scheduler::Scheduler ()
  //## begin Scheduler::Scheduler%3EE0D2BC03A2.hasinit preserve=no
      : curTime(0)
  //## end Scheduler::Scheduler%3EE0D2BC03A2.hasinit
  //## begin Scheduler::Scheduler%3EE0D2BC03A2.initialization preserve=yes
  , first(0)
  //## end Scheduler::Scheduler%3EE0D2BC03A2.initialization
{
  //## begin Scheduler::Scheduler%3EE0D2BC03A2.body preserve=yes
  //## end Scheduler::Scheduler%3EE0D2BC03A2.body
}



//## Other Operations (inline)
inline Time Scheduler::getCurTime ()
{
  //## begin Scheduler::getCurTime%3EE0D4BE0280.body preserve=yes
	return curTime;
  //## end Scheduler::getCurTime%3EE0D4BE0280.body
}

//## begin module%3EEB40C3000A.epilog preserve=yes
//## end module%3EEB40C3000A.epilog


#endif
