class Vector {
public:
	
	Vector(double xx=0, double yy=0) : x(xx), y(yy) {}
	
	friend bool operator== (const Vector& v1, const Vector& v2) 
	{ 
		return v1.x == v2.x && v1.y == v2.y; 
	}
	
	friend bool operator!= (const Vector& v1, const Vector& v2)
	{ 
		return !(v1 == v2); 
	}
	
	friend Vector operator+ (const Vector& v1, const Vector& v2)
	{ 
		return Vector(v1.x + v2.x, v1.y + v2.y ); 
	}
	
	friend Vector operator- (const Vector& v1, const Vector& v2)
	{ 
		return Vector(v1.x - v2.x, v1.y - v2.y ); 
	}
	
	friend double operator* (const Vector& v1, const Vector& v2)
	{ 
		return v1.x * v2.x + v1.y * v2.y ; 
	}
	
	friend Vector operator* (const Vector& v, double s)
	{ 
		return Vector(v.x * s, v.y * s ); 
	}
	
	friend Vector operator* (double s, const Vector& v)
	{ 
		return v*s; 
	} 

private:
	double x, y;
};
