class DocVersion
{
public:
	DocVersion(int verNum) : versionNumber(verNum) {	}
	int getVersionNumber() { return versionNumber; }

private:
	int versionNumber;
};

class Document
{
public:
	Document();
	virtual ~Document();
	void createNewVersion();
	int getTotalVersions();

private:
	// Kolekcija verzija dokumenta je obican dinamicki niz;
	// dinamicki niz se moze zameniti bilo kojom kolekcijom 
	// (CollectionU, std::vector, std::list, ...)
	int totalVersions;
	DocVersion **myVersions;

	// Pomocna metoda za dodavanje verzije u kolekciju verzija
	void addVersionToVersionCollection(DocVersion *pDocVersion);
	// Pomocna metoda za unistavanje svih verzija
	void destroyAllVersions();
};

Document::Document() : totalVersions(0), myVersions(0)
{
	createNewVersion();
}

Document::~Document()
{
	destroyAllVersions();
}

void Document::createNewVersion()
{
	// Stvara se nova verzija...
	DocVersion *pDocVersion = new DocVersion(totalVersions);
	// ... i dodaje u kolekciju verzija
	addVersionToVersionCollection(pDocVersion);
}

int Document::getTotalVersions() 
{ 
	return totalVersions; 
}

void Document::addVersionToVersionCollection(DocVersion *pDocVersion)
{
	DocVersion **temp = new DocVersion*[totalVersions+1];
	if (temp) {	
		for(int i=0; i<totalVersions; i++) {
			temp[i] = myVersions[i];
		}
		temp[totalVersions] = pDocVersion;
		totalVersions++;
		delete [] myVersions;
		myVersions = temp;
	}
}

void Document::destroyAllVersions()
{
	// Unistavanje verzija dokumenta
	for(int i=0; i<totalVersions; i++)
		delete myVersions[i];
	// Dealokacija niza pokazivaca na verzije
	delete [] myVersions;
}
